alias float[4] __m128;
alias double[2] __m128d;
alias int[4] __m128i;
alias float[2] __m64;

void _mm_setcsr(uint a)
{
	asm
	{
		push ECX;
		mov EAX, dword ptr [ESP + 8];
		mov dword ptr [ESP], EAX;
		ldmxcsr dword ptr [ESP];
		pop ECX;
		ret;
	}
}
int _mm_getcsr()
{
	asm
	{
		push ECX;
		stmxcsr dword ptr [ESP];
		mov EAX, dword ptr [ESP];
		pop ECX;
		ret;
	}
}
void _mm_sfence()
{
	asm
	{
		sfence;
		ret;
	}
}
__m128 _mm_move_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_stream_ps(float * a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movntps /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storeu_ps(float *v, __m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movups /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storer_ps(float *v, __m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		shufps XMM0, XMM0, 0x1B;
		movaps /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store_ps(float *v, __m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movaps /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store_ps1(float *v, __m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		shufps XMM0, XMM0, 0;
		movaps /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store_ss(float *v, __m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movss dword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_loadu_ps(const(float)*a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movups XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_loadr_ps(const(float)*a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movaps XMM0,/+xmmword ptr+/ [EAX];
		shufps XMM0, XMM0, 0x1B;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_load_ps(const(float)*a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movaps XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_load_ps1(const(float)*a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movss XMM0, dword ptr [EAX];
		shufps XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_load_ss(const(float)*a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movss XMM0, dword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_setzero_ps()
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		xorps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_setr_ps(float a, float b, float c, float d)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movss XMM0, dword ptr [EBP + 8];
		movss XMM1, dword ptr [EBP + 0x0C];
		movss XMM2, dword ptr [EBP + 0x10];
		movss XMM3, dword ptr [EBP + 0x14];
		unpcklps XMM0, XMM2;
		unpcklps XMM1, XMM3;
		unpcklps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_set_ps(float a, float b, float c, float d)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movss XMM0, dword ptr [EBP + 8];
		movss XMM1, dword ptr [EBP + 0x0C];
		movss XMM2, dword ptr [EBP + 0x10];
		movss XMM3, dword ptr [EBP + 0x14];
		unpcklps XMM2, XMM0;
		unpcklps XMM3, XMM1;
		unpcklps XMM3, XMM2;
		movaps XMM0, XMM3;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_set_ps1(float a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movss XMM0, dword ptr [EBP + 8];
		shufps XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_set_ss(float a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movss XMM0, dword ptr [EBP + 8];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_movemask_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movmskps EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storel_pi(__m64 * a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movlps qword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_loadl_pi(__m128 a, const(__m64)* b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movlps XMM0, qword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storeh_pi(__m64 * a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movhps qword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_movelh_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movlhps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_movehl_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movhlps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_loadh_pi(__m128 a, const(__m64)* b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movhps XMM0, qword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_unpacklo_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		unpcklps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_unpackhi_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		unpckhps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
float _mm_cvtss_f32(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		movss dword ptr [ESP + 4], XMM0;
		fld dword ptr [ESP + 4];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m128 _mm_cvt_pi2ps(__m128 a, __m64 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtpi2ps XMM0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_cvt_si2ss(__m128 a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtsi2ss XMM0, dword ptr [EBP + 8];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_cvtt_ps2pi(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttps2pi mm0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_cvtt_ss2si(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttss2si EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_cvt_ps2pi(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtps2pi mm0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_cvt_ss2si(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtss2si EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomineq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmovne EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomige_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmovae EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomigt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomile_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmovbe EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomilt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomieq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomiss XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comineq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmovne EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comige_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmovae EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comigt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comile_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmovbe EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comilt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comieq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comiss XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpunord_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpunordps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpunord_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpunordss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpord_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpordps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpord_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpordss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnge_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movaps XMM2, XMM0;
		movaps XMM0, XMM1;
		cmpnleps XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnge_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movaps /+xmmword ptr+/ [ESP], XMM0;
		cmpnless XMM1, XMM0;
		movss dword ptr [ESP], XMM1;
		movaps XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpngt_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movaps XMM2, XMM0;
		movaps XMM0, XMM1;
		cmpnltps XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpngt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movaps /+xmmword ptr+/ [ESP], XMM0;
		cmpnltss XMM1, XMM0;
		movss dword ptr [ESP], XMM1;
		movaps XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnle_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnleps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnle_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnless XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnlt_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnltps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpnlt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnltss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpneq_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpneqps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpneq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpneqss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpge_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movaps XMM2, XMM0;
		movaps XMM0, XMM1;
		cmpleps XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}version(UNSUPPORTED)
__m128 _mm_cmpge_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movaps /+xmmword ptr+/ [ESP], XMM0;
		cmpless XMM1, XMM0;
		movss dword ptr [ESP], XMM1;
		movaps XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpgt_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movaps XMM2, XMM0;
		movaps XMM0, XMM1;
		cmpltps XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpgt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movaps /+xmmword ptr+/ [ESP], XMM0;
		cmpltss XMM1, XMM0;
		movss dword ptr [ESP], XMM1;
		movaps XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmple_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpleps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmple_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpless XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmplt_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpltps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmplt_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpltss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpeq_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpeqps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_cmpeq_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpeqss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_xor_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		xorps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_or_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		orps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_andnot_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		andnps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_and_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		andps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_max_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		maxps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_max_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		maxss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_min_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		minps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_min_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		minss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_rsqrt_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		rsqrtps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_rsqrt_ss(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		rsqrtss XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_rcp_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		rcpps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_rcp_ss(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		rcpss XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_sqrt_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sqrtps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_sqrt_ss(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sqrtss XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_div_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		divps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_div_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		divss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_mul_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mulps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_mul_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mulss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_sub_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		subps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_sub_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		subss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_add_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_add_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_aesimc_si128(__m128i v)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		aesimc XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_aesenclast_si128(__m128i v, __m128i rkey)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		aesenclast XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_aesenc_si128(__m128i v, __m128i rkey)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		aesenc XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_aesdeclast_si128(__m128i v, __m128i rkey)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		aesdeclast XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_aesdec_si128(__m128i v, __m128i rkey)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		aesdec XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_stream_load_si128(__m128i* v1)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movntdqa XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_packus_epi32(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		packusdw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepu16_epi64(__m128i shortValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovzxwq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepu32_epi64(__m128i intValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovzxdq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepu16_epi32(__m128i shortValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovzxwd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepi16_epi64(__m128i shortValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovsxwq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepi32_epi64(__m128i intValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovsxdq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtepi16_epi32(__m128i shortValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovsxwd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_minpos_epu16(__m128i shortValues)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		phminposuw XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_testnzc_si128(__m128i mask, __m128i s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ptest XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_testc_si128(__m128i mask, __m128i val)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ptest XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_testz_si128(__m128i mask, __m128i val)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ptest XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mul_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmuldq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mullo_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmulld XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_max_epu32(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaxud XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_min_epu32(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pminud XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_max_epi32(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaxsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_min_epi32(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pminsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_max_epu16(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaxuw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_min_epu16(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pminuw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpeq_epi64(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpeqq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_blendv_pd(__m128d v1, __m128d v2, __m128d v3)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movapd XMM3, XMM0;
		movapd XMM0, XMM2;
		blendvpd XMM3, XMM1, XMM0;
		movapd XMM0, XMM3;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_blendv_ps(__m128 v1, __m128 v2, __m128 v3)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movaps XMM3, XMM0;
		movaps XMM0, XMM2;
		blendvps XMM3, XMM1, XMM0;
		movaps XMM0, XMM3;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_mwait(uint extensions, uint hints)
{
	asm
	{
		mov ECX, dword ptr [ESP + 4];
		mov EAX, dword ptr [ESP + 8];
		mwait EAX, ECX;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_monitor(const(void) *p, uint extensions, uint hints)
{
	asm
	{
		mov EAX, dword ptr [ESP + 4];
		mov ECX, dword ptr [ESP + 8];
		mov edx, dword ptr [ESP + 0x0C];
		monitor EAX, ECX, edx;
		ret;
	}
}
__m128i _mm_lddqu_si128(const(__m128i) *p)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		lddqu XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_movedup_pd(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movddup XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_loaddup_pd(const(double) * dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movddup XMM0, mmword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_hsub_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		hsubpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_hadd_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		haddpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_addsub_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addsubpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_moveldup_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsldup XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_movehdup_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movshdup XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_hsub_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		hsubps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_hadd_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		haddps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_addsub_ps(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addsubps XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_crc32_u32(uint crc, uint v)
{
	asm
	{
		mov EAX, dword ptr [ESP + 8];
		mov ECX, dword ptr [ESP + 4];
		crc32 ECX, EAX;
		mov EAX, ECX;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_crc32_u16(uint crc, ushort v)
{
	asm
	{
		mov ax, word ptr [ESP + 8];
		mov ECX, dword ptr [ESP + 4];
		crc32 cx, ax;
		mov EAX, ECX;
		ret;
	}
}
int _mm_popcnt_u32(uint v)
{
	asm
	{
		popcnt EAX, dword ptr [ESP + 4];
		ret;
	}
}
__m128i _mm_cmpgt_epi64(__m128i val1, __m128i val2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpgtq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_setr_pi16(short s3, short s2, short s1, short s0)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		mov ax, word ptr [EBP + 8];
		mov cx, word ptr [EBP + 0x0C];
		mov dx, word ptr [EBP + 0x10];
		mov word ptr [ESP], ax;
		mov ax, word ptr [EBP + 0x14];
		mov word ptr [ESP + 2], cx;
		mov word ptr [ESP + 4], dx;
		mov word ptr [ESP + 6], ax;
		movq mm0, mmword ptr [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_setr_pi32(int i1, int i0)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		mov EAX, dword ptr [EBP + 8];
		mov ECX, dword ptr [EBP + 0x0C];
		mov dword ptr [ESP], EAX;
		mov dword ptr [ESP + 4], ECX;
		movq mm0, mmword ptr [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_set1_pi8(ubyte b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd mm0, dword ptr [EBP + 8];
		punpcklbw mm0, mm0;
		punpcklbw mm0, mm0;
		punpcklbw mm0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_set1_pi16(short s)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd mm0, dword ptr [EBP + 8];
		punpcklwd mm0, mm0;
		punpcklwd mm0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_set1_pi32(int i)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd mm0, dword ptr [EBP + 8];
		punpckldq mm0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_set_pi16(short s3, short s2, short s1, short s0)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		mov ax, word ptr [EBP + 8];
		mov cx, word ptr [EBP + 0x0C];
		mov dx, word ptr [EBP + 0x10];
		mov word ptr [ESP + 6], ax;
		mov ax, word ptr [EBP + 0x14];
		mov word ptr [ESP + 4], cx;
		mov word ptr [ESP + 2], dx;
		mov word ptr [ESP], ax;
		movq mm0, mmword ptr [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_set_pi32(int i1, int i0)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		mov EAX, dword ptr [EBP + 8];
		mov ECX, dword ptr [EBP + 0x0C];
		mov dword ptr [ESP + 4], EAX;
		mov dword ptr [ESP], ECX;
		movq mm0, mmword ptr [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_setzero_si64()
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pxor mm0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testnzc_ps(__m128 s1, __m128 s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestps XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testc_ps(__m128 s1, __m128 s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestps XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testz_ps(__m128 s1, __m128 s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestps XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testnzc_pd(__m128d s1, __m128d s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestpd XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testc_pd(__m128d s1, __m128d s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestpd XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
int _mm_testz_pd(__m128d s1, __m128d s2)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		vtestpd XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_maskstore_ps(float *a, __m128i mask, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		vmaskmovps /+xmmword ptr+/ [EAX], XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_maskload_ps(const(float) *a, __m128i mask)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		vmaskmovps XMM0, XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_maskstore_pd(double *a, __m128i mask, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		vmaskmovpd /+xmmword ptr+/ [EAX], XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_maskload_pd(const(double) *a, __m128i mask)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		vmaskmovpd XMM0, XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_broadcast_ss(const(float) *a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		vbroadcastss XMM0, dword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_permute_pd(__m128d a, int control)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpermilpd XMM0, XMM0, 0x0C;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_permutevar_pd(__m128d a, __m128i control)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpermilpd XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_permutevar_ps(__m128 a, __m128i control)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpermilps XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_castsi128_pd(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_castsi128_ps(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_castps_si128(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_castps_pd(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_castpd_si128(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_castpd_ps(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
double _mm_cvtsd_f64(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sub ESP, 8;
		movsd mmword ptr [ESP], XMM0;
		fld qword ptr [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_pause()
{
	asm
	{
		pause;
		ret;
	}
}
void _mm_stream_si32(int *p, int i)
{
	asm
	{
		mov EAX, dword ptr [ESP + 4];
		mov ECX, dword ptr [ESP + 8];
		movnti dword ptr [EAX], ECX;
		ret;
	}
}
void _mm_mfence()
{
	asm
	{
		mfence;
		ret;
	}
}
void _mm_lfence()
{
	asm
	{
		lfence;
		ret;
	}
}
void _mm_clflush(const(void)*p)
{
	asm
	{
		mov EAX, dword ptr [ESP + 4];
		clflush [EAX];
		ret;
	}
}
void _mm_stream_si128(__m128i *p, __m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movntdq /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_stream_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movntpd /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_movepi64_pi64(__m128i q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movdq2q mm0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m128i _mm_movpi64_epi64(__m64 q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movq2dq XMM0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_move_epi64(__m128i q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_maskmoveu_si128(__m128i d, __m128i n, ubyte *p)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		push ECX;
		push edi;
		mov edi, dword ptr [EBP + 8];
		maskmovdqu XMM0, XMM1;
		pop edi;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_storel_epi64(__m128i *p, __m128i q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movq mmword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storeu_si128(__m128i *p, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movdqu /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store_si128(__m128i *p, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movdqa /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_setzero_si128()
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pxor XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_setr_epi32(int i0, int i1, int i2, int i3)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM0, dword ptr [EBP + 0x14];
		movd XMM1, dword ptr [EBP + 0x10];
		movd XMM2, dword ptr [EBP + 0x0C];
		movd XMM3, dword ptr [EBP + 8];
		punpckldq XMM2, XMM0;
		punpckldq XMM3, XMM1;
		punpckldq XMM3, XMM2;
		movdqa XMM0, XMM3;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_setl_epi64(__m128i q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_set1_epi8(ubyte b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsx EAX, byte ptr [EBP + 8];
		movd XMM0, EAX;
		punpcklbw XMM0, XMM0;
		punpcklwd XMM0, XMM0;
		pshufd XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_set1_epi16(short w)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsx EAX, word ptr [EBP + 8];
		movd XMM0, EAX;
		punpcklwd XMM0, XMM0;
		pshufd XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_set1_epi32(int i)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM0, dword ptr [EBP + 8];
		pshufd XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m128i _mm_set1_epi64(__m64 q)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movq2dq XMM0, mm0;
		punpcklqdq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_set_epi32(int i3, int i2, int i1, int i0)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM0, dword ptr [EBP + 8];
		movd XMM1, dword ptr [EBP + 0x0C];
		movd XMM2, dword ptr [EBP + 0x10];
		movd XMM3, dword ptr [EBP + 0x14];
		punpckldq XMM2, XMM0;
		punpckldq XMM3, XMM1;
		punpckldq XMM3, XMM2;
		movdqa XMM0, XMM3;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_loadl_epi64(const(__m128i)*p)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movq XMM0, mmword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_loadu_si128(const(__m128i)*p)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movdqu XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_load_si128(const(__m128i)*p)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movdqa XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpacklo_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpcklqdq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpacklo_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpckldq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpacklo_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpcklwd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpacklo_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpcklbw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpackhi_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpckhqdq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpackhi_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpckhdq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpackhi_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpckhwd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_unpackhi_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		punpckhbw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_movemask_epi8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmovmskb EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_packus_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		packuswb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_packs_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		packssdw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_packs_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		packsswb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_cvtsi128_si32(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtsi32_si128(int a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM0, dword ptr [EBP + 8];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmplt_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movdqa XMM2, XMM0;
		movdqa XMM0, XMM1;
		pcmpgtd XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmplt_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movdqa XMM2, XMM0;
		movdqa XMM0, XMM1;
		pcmpgtw XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmplt_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movdqa XMM2, XMM0;
		movdqa XMM0, XMM1;
		pcmpgtb XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpgt_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpgtd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpgt_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpgtw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpgt_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpgtb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpeq_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpeqd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpeq_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpeqw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cmpeq_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pcmpeqb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srl_epi64(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psrlq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srli_epi64(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psrlq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srl_epi32(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psrld XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srli_epi32(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psrld XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srl_epi16(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psrlw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srli_epi16(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psrlw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sra_epi32(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psrad XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srai_epi32(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psrad XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sra_epi16(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psraw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_srai_epi16(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psraw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sll_epi64(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psllq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_slli_epi64(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psllq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sll_epi32(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pslld XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_slli_epi32(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		pslld XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sll_epi16(__m128i a, __m128i count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psllw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_slli_epi16(__m128i a, int count)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movd XMM1, dword ptr [EBP + 8];
		psllw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_xor_si128(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pxor XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_or_si128(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		por XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_andnot_si128(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pandn XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_and_si128(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pand XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_subs_epu16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubusw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_subs_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubusb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_subs_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubsw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_subs_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubsb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sub_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_sub_si64(__m64 a, __m64 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubq mm0, mm1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sub_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sub_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sub_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psubb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_sad_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		psadbw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mul_epu32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmuludq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_mul_su32(__m64 a, __m64 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmuludq mm0, mm1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mullo_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmullw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mulhi_epu16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmulhuw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_mulhi_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmulhw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_min_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pminub XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_min_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pminsw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_max_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaxub XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_max_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaxsw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_madd_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pmaddwd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_avg_epu16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pavgw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_avg_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		pavgb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_adds_epu16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddusw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_adds_epu8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddusb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_adds_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddsw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_adds_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddsb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_add_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddq XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_add_si64(__m64 a, __m64 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddq mm0, mm1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_add_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_add_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddw XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_add_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		paddb XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storel_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movlpd qword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storeh_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movhpd qword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storer_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		shufpd XMM0, XMM0, 1;
		movapd /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_storeu_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movupd /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movapd /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
void _mm_store1_pd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		shufpd XMM0, XMM0, 0;
		movapd /+xmmword ptr+/ [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
void _mm_store_sd(double *dp, __m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movsd mmword ptr [EAX], XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_move_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_setzero_pd()
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		xorpd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_setr_pd(double y, double z)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsd XMM0, mmword ptr [EBP + 8];
		movsd XMM1, mmword ptr [EBP + 0x10];
		unpcklpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_set_pd(double z, double y)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsd XMM0, mmword ptr [EBP + 8];
		movsd XMM1, mmword ptr [EBP + 0x10];
		unpcklpd XMM1, XMM0;
		movapd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_set1_pd(double a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsd XMM0, mmword ptr [EBP + 8];
		unpcklpd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_set_sd(double w)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movsd XMM0, mmword ptr [EBP + 8];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_loadl_pd(__m128d a, const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movlpd XMM0, qword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_loadh_pd(__m128d a, const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movhpd XMM0, qword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_load_sd(const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movsd XMM0, mmword ptr [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_loadu_pd(const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movupd XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_loadr_pd(const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movapd XMM0,/+xmmword ptr+/ [EAX];
		shufpd XMM0, XMM0, 1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_load1_pd(const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movsd XMM0, mmword ptr [EAX];
		shufpd XMM0, XMM0, 0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_load_pd(const(double)*dp)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, dword ptr [EBP + 8];
		movapd XMM0,/+xmmword ptr+/ [EAX];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_movemask_pd(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movmskpd EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_unpacklo_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		unpcklpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_unpackhi_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		unpckhpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m128d _mm_cvtpi32_pd(__m64 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtpi2pd XMM0, mm0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_cvttpd_pi32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttpd2pi mm0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(MM)
__m64 _mm_cvtpd_pi32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtpd2pi mm0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_cvtsi32_sd(__m128d a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtsi2sd XMM0, dword ptr [EBP + 8];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_cvttsd_si32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttsd2si EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_cvtsd_si32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtsd2si EAX, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_cvtss_sd(__m128d a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtss2sd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_cvtsd_ss(__m128 a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtsd2ss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_cvtps_pd(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtps2pd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_cvtpd_ps(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtpd2ps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvttps_epi32(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttps2dq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtps_epi32(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtps2dq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128 _mm_cvtepi32_ps(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtdq2ps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvttpd_epi32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvttpd2dq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128i _mm_cvtpd_epi32(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtpd2dq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_cvtepi32_pd(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cvtdq2pd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomineq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmovne EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomige_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmovae EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomigt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomile_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmovbe EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomilt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_ucomieq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		ucomisd XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comineq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmovne EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comige_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmovae EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comigt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmova EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comile_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmovbe EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comilt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmovb EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
int _mm_comieq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mov EAX, 0;
		mov ECX, 1;
		comisd XMM0, XMM1;
		cmove EAX, ECX;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpunord_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpunordsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpunord_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpunordpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpord_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpordsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpord_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpordpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnge_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movapd XMM2, XMM0;
		movapd XMM0, XMM1;
		cmpnlepd XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnge_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movapd /+xmmword ptr+/ [ESP], XMM0;
		cmpnlesd XMM1, XMM0;
		movsd mmword ptr [ESP], XMM1;
		movapd XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpngt_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movapd XMM2, XMM0;
		movapd XMM0, XMM1;
		cmpnltpd XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpngt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movapd /+xmmword ptr+/ [ESP], XMM0;
		cmpnltsd XMM1, XMM0;
		movsd mmword ptr [ESP], XMM1;
		movapd XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnle_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnlepd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnle_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnlesd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnlt_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnltpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpnlt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpnltsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpneq_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpneqpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpneq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpneqsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpge_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movapd XMM2, XMM0;
		movapd XMM0, XMM1;
		cmplepd XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpge_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movapd /+xmmword ptr+/ [ESP], XMM0;
		cmplesd XMM1, XMM0;
		movsd mmword ptr [ESP], XMM1;
		movapd XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpgt_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movapd XMM2, XMM0;
		movapd XMM0, XMM1;
		cmpltpd XMM0, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpgt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF0;
		sub ESP, 0x10;
		movapd /+xmmword ptr+/ [ESP], XMM0;
		cmpltsd XMM1, XMM0;
		movsd mmword ptr [ESP], XMM1;
		movapd XMM0,/+xmmword ptr+/ [ESP];
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmple_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmplepd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmple_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmplesd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmplt_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpltpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmplt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpltsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpeq_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpeqpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_cmpeq_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		cmpeqsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_xor_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		xorpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_or_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		orpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_andnot_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		andnpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_and_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		andpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_max_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		maxpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_max_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		maxsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_min_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		minpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_min_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		minsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_div_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		divpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_div_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		divsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_sqrt_pd(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sqrtpd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_sqrt_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		sqrtsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_mul_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mulpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_mul_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		mulsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_sub_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		subpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_sub_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		subsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_add_pd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addpd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
__m128d _mm_add_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		addsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_frcz_sd(__m128d a, __m128d b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfrczsd XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_frcz_ss(__m128 a, __m128 b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfrczss XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_frcz_pd(__m128d a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfrczpd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_frcz_ps(__m128 a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfrczps XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_sha_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshaq XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_sha_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshad XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_sha_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshaw XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_sha_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshab XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_shl_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshlq XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_shl_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshld XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_shl_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshlw XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_shl_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpshlb XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_roti_epi64(__m128i a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movzx EAX, byte ptr [EBP + 8];
		movd XMM1, EAX;
		pshufd XMM1, XMM1, 0x44;
		vprotq XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_roti_epi32(__m128i a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movzx EAX, byte ptr [EBP + 8];
		movd XMM1, EAX;
		pshufd XMM1, XMM1, 0;
		vprotd XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_roti_epi16(__m128i a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movzx EAX, byte ptr [EBP + 8];
		imul ECX, EAX, 0x10001;
		movd XMM1, ECX;
		pshufd XMM1, XMM1, 0;
		vprotw XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_roti_epi8(__m128i a, int b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		movzx EAX, byte ptr [EBP + 8];
		imul ECX, EAX, 0x1010101;
		movd XMM1, ECX;
		pshufd XMM1, XMM1, 0;
		vprotb XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_rot_epi64(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vprotq XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_rot_epi32(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vprotd XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_rot_epi16(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vprotw XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_rot_epi8(__m128i a, __m128i b)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vprotb XMM0, XMM0, XMM1;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_perm_epi8(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpperm XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_cmov_si128(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpcmov XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_hsubq_epi32(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphsubdq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_hsubd_epi16(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphsubwd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_hsubw_epi8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphsubbw XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epu32(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddudq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epu16(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphadduwq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddd_epu16(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphadduwd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epu8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddubq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddd_epu8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddubd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddw_epu8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddubw XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epi32(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphadddq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epi16(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddwq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddd_epi16(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddwd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddq_epi8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddbq XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddd_epi8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddbd XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_haddw_epi8(__m128i a)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vphaddbw XMM0, XMM0;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maddd_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmadcswd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maddsd_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmadcsswd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_macchi_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacsdqh XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccshi_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacssdqh XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_macclo_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacsdql XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccslo_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacssdql XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_macc_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacsdd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccs_epi32(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacssdd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccd_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacswd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccsd_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacsswd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_macc_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacsww XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128i _mm_maccs_epi16(__m128i a, __m128i b, __m128i c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vpmacssww XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_nmsub_sd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmsubsd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_nmsub_ss(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmsubss XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_nmsub_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmsubpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_nmsub_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmsubps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_nmacc_sd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmaddsd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_nmacc_ss(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmaddss XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_nmacc_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmaddpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_nmacc_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfnmaddps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_msub_sd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubsd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_msub_ss(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubss XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_msub_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_msub_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_msubadd_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubaddpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_msubadd_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmsubaddps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_maddsub_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddsubpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_maddsub_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddsubps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_macc_sd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddsd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_macc_ss(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddss XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128d _mm_macc_pd(__m128d a, __m128d b, __m128d c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddpd XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
version(UNSUPPORTED)
__m128 _mm_macc_ps(__m128 a, __m128 b, __m128 c)
{
	asm
	{
		push EBP;
		mov EBP, ESP;
		and ESP, 0x0FFFFFFF8;
		vfmaddps XMM0, XMM0, XMM1, XMM2;
		mov ESP, EBP;
		pop EBP;
		ret;
	}
}
